(POJ3267)The Cow Lexicon <DP>

The Cow Lexicon
Description

Few know that the cows have their own dictionary with W (1 ≤ W ≤ 600) words, each containing no more 25 of the characters ‘a’..’z’. Their cowmunication system, based on mooing, is not very accurate; sometimes they hear words that do not make any sense. For instance, Bessie once received a message that said “browndcodw”. As it turns out, the intended message was “browncow” and the two letter “d”s were noise from other parts of the barnyard.

The cows want you to help them decipher a received message (also containing only characters in the range ‘a’..’z’) of length L (2 ≤ L ≤ 300) characters that is a bit garbled. In particular, they know that the message has some extra letters, and they want you to determine the smallest number of letters that must be removed to make the message a sequence of words from the dictionary.

Input

Line 1: Two space-separated integers, respectively: W and L
Line 2: L characters (followed by a newline, of course): the received message
Lines 3..W+2: The cows’ dictionary, one word per line
Output

Line 1: a single integer that is the smallest number of characters that need to be removed to make the message a sequence of dictionary words.
Sample Input

6 10
browndcodw
cow
milk
white
black
brown
farmer
Sample Output

2
Source

USACO 2007 February Silver

题意:
给你一个长度为L的字符串,和W个长度<= 25 的单词。问你最少去掉多少个字母可以使剩下的字符串全部由单词组成?

分析:
设dp[i] 表示将字符串[i,L)的字母变为单词最少要去掉的字母数。
初始条件:dp[L] = 0;
状态转移方程: dp[i] = min(dp[i+1] + 1, dp[t] + t - i - m);
(1):当mes[0] 和所有的单词首字母都不相同时,则dp[i] = dp[i+1] + 1;
(2):判断mes[i,L)中是否包含某个单词(不一定要连续,可以间隔包含)。若某个单词最后一个字母匹配的位置为t-1,那么dp[i] = dp[t] + t - i - m;
如: 单词为cown ,mes=”cowdn” 时 最后匹配的位置为t=5,m=4,所以dp[0] = dp[5] + 5 - 0 - 4 = 1;

函数:string.at(i) 返回第i个字母
string *ws = new string[n];创建大小为n的string数组

AC代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;


int L,W;
string mes;
int dp[310];

int main()
{
    string *ws = new string[610];//创建字符串数组
    while(scanf("%d%d",&W,&L)!=EOF)
    {
        cin>>mes;
        for(int i=0;i<W;i++)
            cin>>ws[i];
        dp[L] = 0;

        for(int i=L-1;i>=0;i--)
        {
            //默认开头字母不匹配
            dp[i] = dp[i+1] + 1;

            //
            for(int j=0;j<W;j++)
            {
                if(L-i>=ws[j].length() && mes[i] == ws[j].at(0))
                {
                    int t = i;
                    int m = 0;
                    while(t < L)
                    {
                        if(ws[j].at(m) == mes[t++])  m++;//注意:当==号不成立时t++,而m不++
                        if(m == ws[j].length())//当匹配了m个字母后,但不一定是连续匹配的
                        {
                            dp[i] = min(dp[i],dp[t]+t-i-m);
                            break;
                        }
                    }
                }
            }
        }
        printf("%d\n",dp[0]);
    }
    return 0;
}
  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值